<template>
  <PageWrapper>
    <el-card :bordered="false" class="pt-3 mb-3 proCard">
      <BasicForm @register="register" @submit="handleSubmit" @reset="handleReset"></BasicForm>
    </el-card>
    <el-card :bordered="false" class="proCard">
      <BasicTable
        :columns="columns"
        :request="loadDataTable"
        :row-key="(row) => row.id"
        ref="tableRef"
        :actionColumn="actionColumn"
         @selection-change="onSelectionChange"
      >
        <template #tableTitle>
          <el-button type="primary" @click="handleAdd" v-perm="['sys:role:add']">
            <template #icon>
              <el-icon class="el-input__icon">
                <PlusOutlined />
              </el-icon>
            </template>
            添加角色
          </el-button>
          <el-button type="danger" @click="handleDelete()" :disabled="!selectionData.length" v-perm="['sys:role:batchDelete']">
              <template #icon>
                <el-icon class="el-input__icon">
                  <Delete />
                </el-icon>
              </template>
              删除
            </el-button>
        </template>
      </BasicTable>
    </el-card>

    <editDialog
        v-if="editVisible"
        :roleId="roleId"
        v-model:visible="editVisible"
        @success="reloadTable('noRefresh')"
    >
    </editDialog>
    <authDialog
        v-if="authVisible"
        :roleId="roleId"
        v-model:visible="authVisible"
        @success="reloadTable('noRefresh')"
    >
    </authDialog>
  </PageWrapper>
</template>

<script lang="ts" setup>
  import { reactive, ref, h,nextTick,defineAsyncComponent } from 'vue';
  import { ColProps } from 'element-plus';
  import { schemas } from './querySchemas';
  import {useForm } from '@/components/Form/index';
  import {TableAction } from '@/components/Table';
  import { getRoleList,roleDelete,roleBatchDelete } from '@/api/system/role';
  import { columns } from './columns';
  import { PlusOutlined } from '@vicons/antd';
  import {message,confirm} from "@/utils/auth";
  const formParams = reactive({
    name:''
  });
  const editDialog = defineAsyncComponent(() =>
    import('./edit.vue')
)
const authDialog = defineAsyncComponent(() =>
    import('./auth.vue')
)
const roleId =ref(0)
const editVisible=ref(false)
const authVisible=ref(false)
  const selectionData = ref([])
  const tableRef = ref();

  const actionColumn = reactive({
    width: 300,
    label: '操作',
    prop: 'action',
    fixed: 'right',
    render(record) {
      return h(TableAction, {
        style: 'button',
        actions: [
          {
            label: '分配权限',
            type: 'warning',
            onClick: handleAuth.bind(null, record),
            // 根据权限控制是否显示: 有权限，会显示，支持多个
            auth: ['sys:role:savePermission'],
          },
          {
            label: '编辑',
            icon:'Edit',
            type: 'warning',
            onClick: handleEdit.bind(null, record),
            auth: ['sys:role:update'],
          },
          {
            label: '删除',
            icon:'Delete',
            type: 'danger',
            onClick: handleDelete.bind(null, record),
            // 根据权限控制是否显示: 有权限，会显示，支持多个
            auth: ['sys:role:delete'],
          },
        ],
      });
    },
  });

  const loadDataTable = async (res: any) => {
    const result = await getRoleList({ ...formParams, ...res });
    return result;
  };

  function reloadTable(noRefresh='') {
    tableRef.value.reload(noRefresh?{}:{pageNo:1});
  }
  const [register, {}] = useForm({
    labelWidth: 80,
    layout: 'horizontal',
    colProps: { span: 6 } as ColProps,
    submitOnReset:true,
    schemas
  });
  function handleSubmit(values: Recordable) {
    handleReset()
    for (const key in values) {
      formParams[key] = values[key]
    }
    reloadTable();
  }

  function handleReset() {
    for (const key in formParams) {
        formParams[key] ='';
    }
  }
  const handleAdd = async () => {
  roleId.value=0
  await nextTick();
  editVisible.value=true
};

const handleEdit = async (record: Recordable) => {
  roleId.value=record.row.id
  await nextTick();
  editVisible.value=true
};
const handleAuth = async (record: Recordable) => {
  roleId.value=record.row.id
  await nextTick();
  authVisible.value=true
};

async function handleDelete(record: Recordable) {
    let ids = []
    if(!record){
      ids = selectionData.value.map(({id}) => id);
    }
    await confirm('确定要删除？');
    record? await roleDelete(record.row.id):await roleBatchDelete(ids);
    message("删除成功");
    reloadTable()
  }
function onSelectionChange(value){
    selectionData.value = value
  }
</script>

<style lang="scss" scoped></style>
